/*--------------------------------------------------------------------------------------
 * Interpolate between two colours.
 *------------------------------------------------------------------------------------*/

color clerp(color c1, color c2, float i)
{
  color r = (int) lerp(red(c1), red(c2), i);
  color g = (int) lerp(green(c1), green(c2), i);
  color b = (int) lerp(blue(c1), blue(c2), i);
  
  return color(r, g, b);
}

color crand()
{
  return color(random(255), random(255), random(255));
}

class ColourFader
{
  color [] colours;
  int current = 0,
      next = 0,
      phase,
      period;
  
  ColourFader(color [] colours, int period)
  {
    this.colours = colours;
    this.period = period;

    this.current = (int) random(colours.length);
    this.next = (int) random(colours.length);
    this.phase = 0;
  }    
  
  ColourFader(color [] colours)
  {
    this(colours, 50);
  }
  
  color get()
  {
    float i = (float) phase / period;
    color c = clerp(colours[current], colours[next], i);
    phase++;
    
    if (phase >= period)
    {
      current = next;
      next = (int) random(colours.length);
      phase = 0;
    }
    
    return c;
  }
}

